package calendarapp.ctrl;

import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Map;

/**
 * A factory producing controllers. All controllers share same interface: Action
 * (by extending AbstractAction)
 * @author adamw
 *
 */
//TODO H1: Remove this class from the project.
public final class ControllerFactory {
	private final static Map<Class<?>, ActionListener> ctrls = new HashMap<Class<?>, ActionListener>();
	
	static {
		ctrls.put(CalendarDayButtonAction.class, new CalendarDayButtonAction());
	}

	public static ActionListener getController(Class<?> ctrl) {
		return ctrls.get(ctrl);
	}

}
