package edu.chl.hajo.monopoly.core;

import java.util.List;

/**
 * The board holding spaces
 *
 * @author hajo
 *
 */
public class Board {

    private final List<Space> spaces;

    public Board(List<Space> spaces) {
        this.spaces = spaces;
    }

    public int size() {
        return spaces.size();
    }

    public Space getStart() {
        return spaces.get(0);
    }
    
    // True if landing on or passing GO (not leaving)
    public boolean passedGo(Space start, Space end) {
        return spaces.indexOf(start) > spaces.indexOf(end);
    }

    public Space getSpace(String name) {
        for (Space s : spaces) {
            if (s.getName().equals(name)) {
                return s;
            }
        }
        return null;
    }
    
    public Space getSpace(int index) {
        return spaces.get(index);
    }

    public Space getSpace(Space actual, int steps) {
        int oldPos = spaces.indexOf(actual);
        int newPos = (oldPos + steps) % spaces.size();
        return spaces.get(newPos);
    }

    @Override
    public String toString() {
        return "Board{" + spaces + '}';
    }

    
}
