package edu.chl.hajo.monopoly.view;

import edu.chl.hajo.monopoly.core.Monopoly;
import edu.chl.hajo.monopoly.event.Event;
import edu.chl.hajo.monopoly.event.EventBus;
import edu.chl.hajo.monopoly.event.IEventHandler;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import static java.lang.System.out;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**

 @author hajo
 */
public class DicePanel extends JPanel implements IEventHandler, ActionListener {

    private final JButton roll = new JButton("Roll");
    private final JButton next = new JButton("Next");
    private final JLabel diceOne = new JLabel("---");
    private final JLabel diceTwo = new JLabel("---");
    private final Monopoly monopoly;

    public DicePanel(Monopoly monopoly, int width, int height) {
        this.monopoly = monopoly;
        initGUI(width, height);
        initEvent();
    }

    @Override
    public void onEvent(Event evt) {
        if (evt.getTag() == Event.Tag.DICE_FST) {
            int i = (int) evt.getValue();
            diceOne.setText(String.valueOf(i));
        } else if (evt.getTag() == Event.Tag.DICE_SEC) {
            int i = (int) evt.getValue();
            diceTwo.setText(String.valueOf(i));
        }
    }

    // This is events going DOWN to model
    @Override
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == roll) {
            //out.println("roll");
            monopoly.move();
            if (monopoly.checkPayRent()) {
                //  Pay Rent Dialog
            }
            roll.setEnabled(false);
            next.setEnabled(true);
        } else if (e.getSource() == next) {
            monopoly.next();
            diceOne.setText("---");
            diceTwo.setText("---");
            roll.setEnabled(true);
            next.setEnabled(false);
        }
    }

    private void initGUI(int width, int height) {
        this.setPreferredSize(new Dimension(width, height));
        this.setBorder(BorderFactory.createEtchedBorder());
        this.add(roll);
        this.add(next);
        this.add(diceOne);
        this.add(diceTwo);
        next.setEnabled(false);
    }

    private void initEvent() {
        roll.addActionListener(this);
        next.addActionListener(this);
        EventBus.BUS.register(this);
    }

}
