package edu.chl.hajo.monopoly.view;


import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.event.Event;
import edu.chl.hajo.monopoly.event.EventBus;
import edu.chl.hajo.monopoly.event.IEventHandler;
import java.awt.Color;
import java.awt.Dimension;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**

 @author hajo
 */
public class PlayerPanel extends JPanel implements IEventHandler {

    private final JLabel name = new JLabel();
    private final JLabel balance = new JLabel();
    private final String playerName;
    private final Color DEFAULT = getBackground();

    public PlayerPanel(Player player, int width, int height) {
        // Unique key!
        this.playerName = player.getName();
        initGUI(player, width, height);
        initEvent();
    }

    @Override
    public void onEvent(Event evt) {
        if (evt.getTag() == Event.Tag.PLAYER_BALANCE) {
            Player p = (Player) evt.getValue();
            if (p.getName().equals(playerName)) {
                balance.setText(String.valueOf(p.getBalance()));
            }
        } else if (evt.getTag() == Event.Tag.MONOPOLY_NEXT) {
            Player p = (Player) evt.getValue();
            if (p.getName().equals(playerName)) {
                setBackground(Color.YELLOW);
            } else {
                setBackground(DEFAULT);
            }
        }
    }

    private void initGUI(Player player, int width, int height) {
        this.setPreferredSize(new Dimension(width, height));
        this.setBorder(BorderFactory.createEtchedBorder());
        this.add(name);
        this.add(balance);
        name.setText(player.getName());
        balance.setText(String.valueOf(player.getBalance()));
    }

    private void initEvent() {
        EventBus.BUS.register(this);
    }
}
